
;Help SDK
;http://www.microsoft.com/downloads/en/details.aspx?displaylang=en&FamilyID=94ab4784-b7c3-49ac-a315-9688bc5c84c3
;05_HelpSDK_API_Reference.htm

.NOLIST			;signifie: ne rien mettre dans le listing
;------ emplacement des dclarations
	.486
	.model flat, stdcall
	option casemap :none   ; case sensitive

	include translate.inc	;SDK translate include files (voir mon site)
	include windows.sdk
	include WTSAPI32.sdk
	include WinINet.sdk
	include shellapi.sdk
	include macros.inc
	;------- librairie courantes ,identiques masm32rt	
      includelib user32.lib
      includelib kernel32.lib
      includelib shell32.lib
      includelib ole32.lib
	includelib WTSAPI32.lib
	includelib advapi32.lib
	.const
	WTSFindProcess PROTO  :DWORD , :DWORD
	LireCleMs_xhelp PROTO 	
	
SDKOSVERSIONINFOEX	STRUCT
	dwOSVersionInfoSize DWORD ?
	dwMajorVersion DWORD ?
	dwMinorVersion DWORD ?
	dwBuildNumber DWORD ?
	dwPlatformId DWORD ?
	szCSDVersion BYTE 128 dup (?)  ;error in translate SDK QWORD
	wServicePackMajor WORD ?
	wServicePackMinor WORD ?
	wSuiteMask WORD ?
	wProductType BYTE ?
	wReserved BYTE ?
SDKOSVERSIONINFOEX		ENDS		
	.data
	pSessionId dd 0
	bytesReturned dd 0
	HelpName db "HelpLibAgent.exe",0
	FixedF1Query db "ms-xhelp:///?method=f1&query=",0
	FixedSearchQuery db "ms-xhelp:///?method=search&query=",0
	FixedPageId db "ms-xhelp:///?method=page&id=",0
	FixedSearchQueryEnd db "&ProductVersion=100&Product=vs&PageSize=10&PageNumber=1&locale=en-us",0
	FixedPageIdEnd db "&product=vs&productversion=100&locale=en-us",0
	FixedF1QueryEnd	db "&product=vs&productversion=100&locale=en-us",0
	;ShellName db "ms-xhelp:///?method=page&id=FFB79C0F-AEDA-4EA1-AEA8-AFB79109837F&product=vs&productversion=100&locale=en-us",0
	;ShellName db "ms-xhelp:///?method=search&query=resource compiler&ProductVersion=100&Product=vs&PageSize=10&PageNumber=1&locale=en-us",0
	ShellName db MAX_PATH dup (0)
	ShellVerb db "open",0 ;"NULL",0
	ShellVerbedit db "edit",0 ;"NULL",0
	NullChaine dd 0
	HkeyXhelp dd 0
	;XhelpActionKey dd 0
	KeyPathHlibAgent db "SOFTWARE\Microsoft\Help\v1.0",0 ; 
	PathHelplibAgent db MAX_PATH + 5 dup(0)
	Xhelpsizebuff dd MAX_PATH + 5
	Win7 dd 0
	osvi SDKOSVERSIONINFOEX <>	
	.code
	;WTSInfoClass.
	start:
	;---------------------------------------------------------------------------------
	;detect WIN7 who have a special registry value 
	;read HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Help\v1.0 Value=LocalStore
	;read HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Help\v1.0 Value=AppRoot   ;Win7
	mov osvi.dwOSVersionInfoSize,sizeof SDKOSVERSIONINFOEX
	invoke GetVersionEx,addr osvi
	.if eax == TRUE  ;FALSE need OSVERSION to work
		.if osvi.dwMajorVersion == 6
			.if osvi.dwMinorVersion >= 1
				;Win7 system
				mov Win7,1
			.endif 
		.endif
	.endif
	;------------------------------------------------------------------------------	
	
	invoke CoInitializeEx,NULL, COINIT_APARTMENTTHREADED OR COINIT_DISABLE_OLE1DDE
	invoke LireCleMs_xhelp
	.if eax == 0
		;Not found
		jmp findeprog
	.endif
		mov dword ptr [ShellName],0
		invoke lstrcat,addr ShellName,addr FixedF1Query
		invoke lstrcat,addr ShellName,SADR("enumwindows") 
		invoke lstrcat,addr ShellName,addr FixedF1QueryEnd
		;PathHelplibAgent point on the path help content
		;Those paths are differents for XP,Vista,Win 7
		;Syntax of ShellName is explain in 05_HelpSDK_API_Reference.htm
		invoke ShellExecute,NULL,addr ShellVerb,addr ShellName,addr NullChaine,\
		addr PathHelplibAgent,SW_SHOWDEFAULT

	findeprog:
	invoke CoUninitialize
	invoke ExitProcess,0

;################################################################
WTSFindProcess PROC uses esi edi pname:DWORD,Pprocess_info:DWORD 
			Local parrayWTS_PROCESS_INFO:DWORD,NumberStruct
			Local  retour:DWORD
			
			;Local   :DWORD
         mov retour,0
	invoke WTSEnumerateProcesses,WTS_CURRENT_SERVER_HANDLE,NULL,1,\
						addr parrayWTS_PROCESS_INFO,addr NumberStruct
	
	.if eax != 0
		mov esi,parrayWTS_PROCESS_INFO
		sub esi,sizeof WTS_PROCESS_INFO
		mov edx,NumberStruct
		readname:
		push edx
		add esi,sizeof WTS_PROCESS_INFO
		mov edx,[esi].WTS_PROCESS_INFO.pProcessName
		invoke lstrcmpi,pname,edx
		pop edx
		.if eax != 0
			dec edx
			jnz readname		
		.endif
		.if eax == 0
			;trouv
			mov ecx,sizeof WTS_PROCESS_INFO
			mov edi,Pprocess_info
			rep movsb
			mov retour,1
		.endif
		;invalid the pointer on the name of the process but we know it
		invoke WTSFreeMemory,parrayWTS_PROCESS_INFO
	.endif

 FindeWTSFindProcess:
         mov eax,retour
         ret
WTSFindProcess endp

;################################################################

;################################################################
LireCleMs_xhelp PROC uses esi edi
			Local  retour:DWORD
         mov retour,0
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr KeyPathHlibAgent,NULL,KEY_READ OR KEY_QUERY_VALUE,addr HkeyXhelp
	.if eax != ERROR_SUCCESS
		;n'existe pas
		jmp FindeLireCleMs_xhelp
	.endif
	.if Win7 == 0
		invoke RegQueryValueEx,HkeyXhelp,SADR("LocalStore"),NULL,NULL,\
				addr PathHelplibAgent,addr Xhelpsizebuff
	.else
		invoke RegQueryValueEx,HkeyXhelp,SADR("AppRoot"),NULL,NULL,\
				addr PathHelplibAgent,addr Xhelpsizebuff	
	.endif
	.if eax != ERROR_SUCCESS
		jmp FindeLireCleMs_xhelp
	.endif				
	invoke RegCloseKey,HkeyXhelp
	;filtrer entre ""
	mov retour,1
 FindeLireCleMs_xhelp:
         mov eax,retour
         ret
LireCleMs_xhelp endp

comment 
	SecuAttr	SECURITY_ATTRIBUTES <sizeof SECURITY_ATTRIBUTES,NULL,TRUE> 
	process_info WTS_PROCESS_INFO <>
	startInfo     STARTUPINFO <>   ;structure API CreateProcess
	processInfo   PROCESS_INFORMATION <> ;structure API	
;WTS_PROCESS_INFOA	STRUCT
;	SessionId DWORD ? ; session id
;	ProcessId DWORD ? ; process id
;	pProcessName DWORD ? ; name of process
;	pUserSid DWORD ? ; user's SID
;WTS_PROCESS_INFOA		ENDS	

	invoke WTSFindProcess,addr HelpName,addr process_info
	.if eax == 0 ;pas trouv
		;lancer le process
		invoke Execute_Independant_Win,NULL,NULL,addr PathHelplibAgent
		;invoke ShellExecute,NULL,addr ShellVerb,addr ShellName,addr NullChaine,NULL,SW_SHOWDEFAULT
		;recommencer
		invoke WTSFindProcess,addr HelpName,addr process_info
		.if eax == 0
			jmp findeprog
		.endif
	.endif
	lea edx,process_info
	mov eax,[edx].WTS_PROCESS_INFO.SessionId
	mov eax,[edx].WTS_PROCESS_INFO.ProcessId		
	invoke WTSQuerySessionInformation,WTS_CURRENT_SERVER_HANDLE,WTS_CURRENT_SESSION,
			WTSSessionId, addr pSessionId,addr bytesReturned
	
;ppBuffer [out]
;A pointer to a variable that receives a pointer to the 
;requested information. The format and contents of the data
;depend on the information class specified in the WTSInfoClass
;parameter. To free the returned buffer, call the WTSFreeMemory
;function.			
	.if eax != 0
		mov eax,bytesReturned
		mov edx,pSessionId
		mov eax,[edx]
		invoke WTSFreeMemory,pSessionId
	.endif



	
	
	;------- proc ii ------------
	end start		
	
